
_interrupt:

;IRrxSony.c,37 :: 		void interrupt(){
;IRrxSony.c,38 :: 		if (INTF_bit){                                 // RA2 external Interrupt
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L_interrupt0
;IRrxSony.c,39 :: 		switch(current_state){
	GOTO       L_interrupt1
;IRrxSony.c,40 :: 		case 1:   //Idle,starting
L_interrupt3:
;IRrxSony.c,41 :: 		current_state = 2;
	MOVLW      2
	MOVWF      _current_state+0
;IRrxSony.c,42 :: 		INTEDG_bit = 1;                        // interrupt on rising edge
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IRrxSony.c,43 :: 		break;
	GOTO       L_interrupt2
;IRrxSony.c,44 :: 		case 2:   // start_bit, found rising edge, check length for 2.4ms
L_interrupt4:
;IRrxSony.c,45 :: 		counter = TMR1L;                       // also loads TMR1 H
	MOVF       TMR1L+0, 0
	MOVWF      _counter+0
	CLRF       _counter+1
;IRrxSony.c,46 :: 		counter += (TMR1H * 256);              // combine timer 1 high and low
	MOVF       TMR1H+0, 0
	MOVWF      R1
	CLRF       R0
	MOVF       R0, 0
	ADDWF      _counter+0, 0
	MOVWF      R2
	MOVF       R1, 0
	ADDWFC     _counter+1, 0
	MOVWF      R3
	MOVF       R2, 0
	MOVWF      _counter+0
	MOVF       R3, 0
	MOVWF      _counter+1
;IRrxSony.c,47 :: 		if((counter > 2000) && (counter < 2800)){   // acceptable uS values for start
	MOVF       R3, 0
	SUBLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt30
	MOVF       R2, 0
	SUBLW      208
L__interrupt30:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt7
	MOVLW      10
	SUBWF      _counter+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt31
	MOVLW      240
	SUBWF      _counter+0, 0
L__interrupt31:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt7
L__interrupt27:
;IRrxSony.c,48 :: 		bit_count = 0;                     // start counting bits in
	CLRF       _bit_count+0
;IRrxSony.c,49 :: 		input_data = 0;                    // clear old value
	CLRF       _input_data+0
	CLRF       _input_data+1
;IRrxSony.c,50 :: 		current_state = 3;                 // start receiving bits
	MOVLW      3
	MOVWF      _current_state+0
;IRrxSony.c,51 :: 		}
	GOTO       L_interrupt8
L_interrupt7:
;IRrxSony.c,53 :: 		current_state = 1;
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,54 :: 		INTEDG_bit = 0;                    // interrupt on falling edge
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IRrxSony.c,55 :: 		}
L_interrupt8:
;IRrxSony.c,56 :: 		break;
	GOTO       L_interrupt2
;IRrxSony.c,57 :: 		case 3:   //capture bit, start receiving data
L_interrupt9:
;IRrxSony.c,60 :: 		counter = TMR1L;                       // also loads TMR1 H
	MOVF       TMR1L+0, 0
	MOVWF      _counter+0
	CLRF       _counter+1
;IRrxSony.c,61 :: 		counter += (TMR1H * 256);              // combine timer 1 high and low
	MOVF       TMR1H+0, 0
	MOVWF      R1
	CLRF       R0
	MOVF       R0, 0
	ADDWF      _counter+0, 0
	MOVWF      R2
	MOVF       R1, 0
	ADDWFC     _counter+1, 0
	MOVWF      R3
	MOVF       R2, 0
	MOVWF      _counter+0
	MOVF       R3, 0
	MOVWF      _counter+1
;IRrxSony.c,62 :: 		bit_count++;
	INCF       _bit_count+0, 1
;IRrxSony.c,63 :: 		input_data >>= 1;                      // make room for 0 bit
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
;IRrxSony.c,65 :: 		if(counter > 1500){                    // acceptable uS values for zero/one discrimination
	MOVF       R3, 0
	SUBLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt32
	MOVF       R2, 0
	SUBLW      220
L__interrupt32:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt10
;IRrxSony.c,66 :: 		input_data |= 0x8000;              // change 0 to 1
	BSF        _input_data+1, 7
;IRrxSony.c,67 :: 		}
L_interrupt10:
;IRrxSony.c,68 :: 		if (bit_count == 12){                  // complete 12 bits
	MOVF       _bit_count+0, 0
	XORLW      12
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt11
;IRrxSony.c,69 :: 		ir_found = 1;                      // indicate that a message is ready
	MOVLW      1
	MOVWF      _ir_found+0
;IRrxSony.c,70 :: 		input_data >>= 4;                  // shift 12 bits into lower bits of word
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
;IRrxSony.c,71 :: 		current_state = 1;                 // ready to start receiving again
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,72 :: 		}
L_interrupt11:
;IRrxSony.c,73 :: 		break;
	GOTO       L_interrupt2
;IRrxSony.c,74 :: 		default: current_state = 1;
L_interrupt12:
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,75 :: 		}
	GOTO       L_interrupt2
L_interrupt1:
	MOVF       _current_state+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt3
	MOVF       _current_state+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt4
	MOVF       _current_state+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt9
	GOTO       L_interrupt12
L_interrupt2:
;IRrxSony.c,76 :: 		TMR1H = 0x00;                              // reset timer
	CLRF       TMR1H+0
;IRrxSony.c,77 :: 		TMR1L = 0x00;
	CLRF       TMR1L+0
;IRrxSony.c,78 :: 		INTF_bit = 0;                              // clear Interrupt flag
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
;IRrxSony.c,79 :: 		}
L_interrupt0:
;IRrxSony.c,81 :: 		if (TMR1IF_bit)                                // Timer1 overflow
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_interrupt13
;IRrxSony.c,83 :: 		current_state = 1;                         // timer has overflowed - so return to idle
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,84 :: 		TMR1IF_bit = 0;                            // clear Interrupt flag
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;IRrxSony.c,85 :: 		}
L_interrupt13:
;IRrxSony.c,86 :: 		}
L_end_interrupt:
L__interrupt29:
	RETFIE     %s
; end of _interrupt

_main:

;IRrxSony.c,89 :: 		void main() {
;IRrxSony.c,90 :: 		OSCCON = 0x70;                       // internal 8MHz x4 PLL gives 32 MHz clock
	MOVLW      112
	MOVWF      OSCCON+0
;IRrxSony.c,91 :: 		ANSELA = 0x00;                       // configure all pins as digital
	CLRF       ANSELA+0
;IRrxSony.c,92 :: 		TRISA = 0x04;                        // IR input on A2
	MOVLW      4
	MOVWF      TRISA+0
;IRrxSony.c,93 :: 		LATA = 0;                            // PORTA outputs all low
	CLRF       LATA+0
;IRrxSony.c,95 :: 		INTEDG_bit = 0;                      // interrupt on falling edge
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IRrxSony.c,97 :: 		T1CON  = 0x31;                       // Timer 1 on, FOSC/4, 2:1, internal osc gives mS count
	MOVLW      49
	MOVWF      T1CON+0
;IRrxSony.c,98 :: 		TMR1H = 0x00;                        // reset timer
	CLRF       TMR1H+0
;IRrxSony.c,99 :: 		TMR1L = 0x00;
	CLRF       TMR1L+0
;IRrxSony.c,100 :: 		INTCON = 0xC0;                       // Eneble peripheral and global interrupts
	MOVLW      192
	MOVWF      INTCON+0
;IRrxSony.c,101 :: 		TMR1IE_bit = 1;
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;IRrxSony.c,102 :: 		INTE_bit = 1;                        // Enable RA2 Interrupt
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;IRrxSony.c,104 :: 		current_state = 1;                   // Idle
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,105 :: 		counter = 0;
	CLRF       _counter+0
	CLRF       _counter+1
;IRrxSony.c,106 :: 		ir_found = 0;
	CLRF       _ir_found+0
;IRrxSony.c,108 :: 		while(1){                                       // Infinite loop
L_main14:
;IRrxSony.c,109 :: 		if(ir_found){
	MOVF       _ir_found+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main16
;IRrxSony.c,110 :: 		command_id = input_data & 0x7F;
	MOVLW      127
	ANDWF      _input_data+0, 0
	MOVWF      _command_id+0
;IRrxSony.c,111 :: 		device_id = input_data >> 7;            // break input data to two parts
	MOVLW      7
	MOVWF      R0
	MOVF       _input_data+0, 0
	MOVWF      R1
	MOVF       _input_data+1, 0
	MOVWF      R2
	MOVF       R0, 0
L__main34:
	BTFSC      STATUS+0, 2
	GOTO       L__main35
	LSRF       R2, 1
	RRF        R1, 1
	ADDLW      255
	GOTO       L__main34
L__main35:
	MOVF       R1, 0
	MOVWF      _device_id+0
;IRrxSony.c,112 :: 		ir_found = 0;                           // clear the flag for new message
	CLRF       _ir_found+0
;IRrxSony.c,113 :: 		if(device_id == 1){                     // Sony TV
	MOVF       R1, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main17
;IRrxSony.c,114 :: 		switch(command_id){                 // convert number to ASCII hex
	GOTO       L_main18
;IRrxSony.c,115 :: 		case 0:                         // "1" button
L_main20:
;IRrxSony.c,116 :: 		LATA.B0 = !LATA.B0;         // Toggle LED/relay on RA0
	MOVLW      1
	XORWF      LATA+0, 1
;IRrxSony.c,117 :: 		break;
	GOTO       L_main19
;IRrxSony.c,118 :: 		case 1:                         // "2" button
L_main21:
;IRrxSony.c,119 :: 		LATA.B1 = !LATA.B1;         // Toggle LED/relay on RA1
	MOVLW      2
	XORWF      LATA+0, 1
;IRrxSony.c,120 :: 		break;
	GOTO       L_main19
;IRrxSony.c,121 :: 		case 2:                         // "3" button
L_main22:
;IRrxSony.c,122 :: 		LATA.B4 = !LATA.B4;         // Toggle LED/relay on RA4
	MOVLW      16
	XORWF      LATA+0, 1
;IRrxSony.c,123 :: 		break;
	GOTO       L_main19
;IRrxSony.c,124 :: 		case 3:                         // "4" button
L_main23:
;IRrxSony.c,125 :: 		LATA.B5 = !LATA.B5;         // Toggle LED/relay on RA5
	MOVLW      32
	XORWF      LATA+0, 1
;IRrxSony.c,126 :: 		break;
	GOTO       L_main19
;IRrxSony.c,127 :: 		case 8:                         // "9" button
L_main24:
;IRrxSony.c,128 :: 		LATA = 0xff;                // all LEDs/relays on
	MOVLW      255
	MOVWF      LATA+0
;IRrxSony.c,129 :: 		break;
	GOTO       L_main19
;IRrxSony.c,130 :: 		case 9:                         // "0" button
L_main25:
;IRrxSony.c,131 :: 		LATA = 0;                   // all LEDs/relays off
	CLRF       LATA+0
;IRrxSony.c,132 :: 		break;
	GOTO       L_main19
;IRrxSony.c,133 :: 		}
L_main18:
	MOVF       _command_id+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_main20
	MOVF       _command_id+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_main21
	MOVF       _command_id+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_main22
	MOVF       _command_id+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_main23
	MOVF       _command_id+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L_main24
	MOVF       _command_id+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L_main25
L_main19:
;IRrxSony.c,134 :: 		Delay_ms(100);                      // wait until repeat messages finished...
	MOVLW      5
	MOVWF      R11
	MOVLW      15
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L_main26:
	DECFSZ     R13, 1
	GOTO       L_main26
	DECFSZ     R12, 1
	GOTO       L_main26
	DECFSZ     R11, 1
	GOTO       L_main26
;IRrxSony.c,136 :: 		current_state = 1;                  // Idle - kill repeat message in progress
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,137 :: 		counter = 0;
	CLRF       _counter+0
	CLRF       _counter+1
;IRrxSony.c,138 :: 		ir_found = 0;
	CLRF       _ir_found+0
;IRrxSony.c,139 :: 		}
L_main17:
;IRrxSony.c,140 :: 		}
L_main16:
;IRrxSony.c,141 :: 		}
	GOTO       L_main14
;IRrxSony.c,142 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
