
_interrupt:

;IRrxSony.c,40 :: 		void interrupt(){
;IRrxSony.c,41 :: 		if (INTF_bit){                                 // RA2 external Interrupt
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L_interrupt0
;IRrxSony.c,42 :: 		switch(current_state){
	GOTO       L_interrupt1
;IRrxSony.c,43 :: 		case 1:   //Idle,starting
L_interrupt3:
;IRrxSony.c,44 :: 		current_state = 2;
	MOVLW      2
	MOVWF      _current_state+0
;IRrxSony.c,45 :: 		INTEDG_bit = 1;                        // interrupt on rising edge
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IRrxSony.c,46 :: 		break;
	GOTO       L_interrupt2
;IRrxSony.c,47 :: 		case 2:   // start_bit, found rising edge, check length for 2.4ms
L_interrupt4:
;IRrxSony.c,48 :: 		counter = TMR1L;                       // also loads TMR1 H
	MOVF       TMR1L+0, 0
	MOVWF      _counter+0
	CLRF       _counter+1
;IRrxSony.c,49 :: 		counter += (TMR1H * 256);              // combine timer 1 high and low
	MOVF       TMR1H+0, 0
	MOVWF      R1
	CLRF       R0
	MOVF       R0, 0
	ADDWF      _counter+0, 0
	MOVWF      R2
	MOVF       R1, 0
	ADDWFC     _counter+1, 0
	MOVWF      R3
	MOVF       R2, 0
	MOVWF      _counter+0
	MOVF       R3, 0
	MOVWF      _counter+1
;IRrxSony.c,50 :: 		if((counter > 2000) && (counter < 2800)){   // acceptable uS values for start
	MOVF       R3, 0
	SUBLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt21
	MOVF       R2, 0
	SUBLW      208
L__interrupt21:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt7
	MOVLW      10
	SUBWF      _counter+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt22
	MOVLW      240
	SUBWF      _counter+0, 0
L__interrupt22:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt7
L__interrupt18:
;IRrxSony.c,51 :: 		bit_count = 0;                     // start counting bits in
	CLRF       _bit_count+0
;IRrxSony.c,52 :: 		input_data = 0;                    // clear old value
	CLRF       _input_data+0
	CLRF       _input_data+1
;IRrxSony.c,53 :: 		current_state = 3;                 // start receiving bits
	MOVLW      3
	MOVWF      _current_state+0
;IRrxSony.c,54 :: 		}
	GOTO       L_interrupt8
L_interrupt7:
;IRrxSony.c,56 :: 		current_state = 1;
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,57 :: 		INTEDG_bit = 0;                    // interrupt on falling edge
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IRrxSony.c,58 :: 		}
L_interrupt8:
;IRrxSony.c,59 :: 		break;
	GOTO       L_interrupt2
;IRrxSony.c,60 :: 		case 3:   //capture bit, start receiving data
L_interrupt9:
;IRrxSony.c,63 :: 		counter = TMR1L;                       // also loads TMR1 H
	MOVF       TMR1L+0, 0
	MOVWF      _counter+0
	CLRF       _counter+1
;IRrxSony.c,64 :: 		counter += (TMR1H * 256);              // combine timer 1 high and low
	MOVF       TMR1H+0, 0
	MOVWF      R1
	CLRF       R0
	MOVF       R0, 0
	ADDWF      _counter+0, 0
	MOVWF      R2
	MOVF       R1, 0
	ADDWFC     _counter+1, 0
	MOVWF      R3
	MOVF       R2, 0
	MOVWF      _counter+0
	MOVF       R3, 0
	MOVWF      _counter+1
;IRrxSony.c,65 :: 		bit_count++;
	INCF       _bit_count+0, 1
;IRrxSony.c,66 :: 		input_data >>= 1;                      // make room for 0 bit
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
;IRrxSony.c,68 :: 		if(counter > 1500){                    // acceptable uS values for zero/one discrimination
	MOVF       R3, 0
	SUBLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt23
	MOVF       R2, 0
	SUBLW      220
L__interrupt23:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt10
;IRrxSony.c,69 :: 		input_data |= 0x8000;              // change 0 to 1
	BSF        _input_data+1, 7
;IRrxSony.c,70 :: 		}
L_interrupt10:
;IRrxSony.c,71 :: 		if (bit_count == 12){                  // complete 12 bits
	MOVF       _bit_count+0, 0
	XORLW      12
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt11
;IRrxSony.c,72 :: 		ir_found = 1;                      // indicate that a message is ready
	MOVLW      1
	MOVWF      _ir_found+0
;IRrxSony.c,73 :: 		input_data >>= 4;                  // shift 12 bits into lower bits of word
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
	LSRF       _input_data+1, 1
	RRF        _input_data+0, 1
;IRrxSony.c,74 :: 		current_state = 1;                 // ready to start receiving again
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,75 :: 		}
L_interrupt11:
;IRrxSony.c,76 :: 		break;
	GOTO       L_interrupt2
;IRrxSony.c,77 :: 		default: current_state = 1;
L_interrupt12:
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,78 :: 		}
	GOTO       L_interrupt2
L_interrupt1:
	MOVF       _current_state+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt3
	MOVF       _current_state+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt4
	MOVF       _current_state+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_interrupt9
	GOTO       L_interrupt12
L_interrupt2:
;IRrxSony.c,79 :: 		TMR1H = 0x00;                              // reset timer
	CLRF       TMR1H+0
;IRrxSony.c,80 :: 		TMR1L = 0x00;
	CLRF       TMR1L+0
;IRrxSony.c,81 :: 		INTF_bit = 0;                              // clear Interrupt flag
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
;IRrxSony.c,82 :: 		}
L_interrupt0:
;IRrxSony.c,84 :: 		if (TMR1IF_bit)                                // Timer1 overflow
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_interrupt13
;IRrxSony.c,86 :: 		PORTA.B4 = ~PORTA.B4;                      // debug only
	MOVLW      16
	XORWF      PORTA+0, 1
;IRrxSony.c,87 :: 		current_state = 1;                         // timer has overflowed - so return to idle
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,88 :: 		TMR1IF_bit = 0;                            // clear Interrupt flag
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;IRrxSony.c,89 :: 		}
L_interrupt13:
;IRrxSony.c,90 :: 		}
L_end_interrupt:
L__interrupt20:
	RETFIE     %s
; end of _interrupt

_main:

;IRrxSony.c,93 :: 		void main() {
;IRrxSony.c,94 :: 		OSCCON = 0x70;                       // internal 8MHz x4 PLL gives 32 MHz clock
	MOVLW      112
	MOVWF      OSCCON+0
;IRrxSony.c,95 :: 		ANSELA = 0x00;                       // configure all pins as digital
	CLRF       ANSELA+0
;IRrxSony.c,96 :: 		TRISA = 0x04;                        // IR input on A2
	MOVLW      4
	MOVWF      TRISA+0
;IRrxSony.c,97 :: 		LATA = 0;                            // PORTA outputs all low (used for debug)
	CLRF       LATA+0
;IRrxSony.c,99 :: 		INTEDG_bit = 0;                      // interrupt on falling edge
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IRrxSony.c,101 :: 		T1CON  = 0x31;                       // Timer 1 on, FOSC/4, 2:1, internal osc gives mS count
	MOVLW      49
	MOVWF      T1CON+0
;IRrxSony.c,102 :: 		TMR1H = 0x00;                        // reset timer
	CLRF       TMR1H+0
;IRrxSony.c,103 :: 		TMR1L = 0x00;
	CLRF       TMR1L+0
;IRrxSony.c,104 :: 		INTCON = 0xC0;                       // Eneble peripheral and global interrupts
	MOVLW      192
	MOVWF      INTCON+0
;IRrxSony.c,105 :: 		TMR1IE_bit = 1;
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;IRrxSony.c,106 :: 		INTE_bit = 1;                        // Enable RA2 Interrupt
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;IRrxSony.c,109 :: 		UART1_Init(115200);                  // Initialise UART
	BSF        BAUDCON+0, 3
	MOVLW      68
	MOVWF      SPBRG+0
	MOVLW      0
	MOVWF      SPBRG+1
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;IRrxSony.c,110 :: 		Delay_ms(100);                       // allow time for UART to settle
	MOVLW      5
	MOVWF      R11
	MOVLW      15
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L_main14:
	DECFSZ     R13, 1
	GOTO       L_main14
	DECFSZ     R12, 1
	GOTO       L_main14
	DECFSZ     R11, 1
	GOTO       L_main14
;IRrxSony.c,111 :: 		UART1_Write_Text("\r\n\nSony IR  (Hex)\r\n");
	MOVLW      ?lstr1_IRrxSony+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?lstr1_IRrxSony+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;IRrxSony.c,113 :: 		current_state = 1;                   // Idle
	MOVLW      1
	MOVWF      _current_state+0
;IRrxSony.c,114 :: 		counter = 0;
	CLRF       _counter+0
	CLRF       _counter+1
;IRrxSony.c,115 :: 		ir_found = 0;
	CLRF       _ir_found+0
;IRrxSony.c,117 :: 		while(1){                                       // Infinite loop
L_main15:
;IRrxSony.c,118 :: 		if(ir_found){
	MOVF       _ir_found+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main17
;IRrxSony.c,119 :: 		command_id = input_data & 0x7F;
	MOVLW      127
	ANDWF      _input_data+0, 0
	MOVWF      R3
	MOVF       R3, 0
	MOVWF      _command_id+0
;IRrxSony.c,120 :: 		device_id = input_data >> 7;            // break input data to two parts
	MOVLW      7
	MOVWF      R2
	MOVF       _input_data+0, 0
	MOVWF      R0
	MOVF       _input_data+1, 0
	MOVWF      R1
	MOVF       R2, 0
L__main25:
	BTFSC      STATUS+0, 2
	GOTO       L__main26
	LSRF       R1, 1
	RRF        R0, 1
	ADDLW      255
	GOTO       L__main25
L__main26:
	MOVF       R0, 0
	MOVWF      _device_id+0
;IRrxSony.c,121 :: 		ir_found = 0;                           // clear the flag for new message
	CLRF       _ir_found+0
;IRrxSony.c,123 :: 		ByteToHex(command_id,word_text);    // convert number to ASCII hex
	MOVF       R3, 0
	MOVWF      FARG_ByteToHex_input+0
	MOVLW      _word_text+0
	MOVWF      FARG_ByteToHex_output+0
	MOVLW      hi_addr(_word_text+0)
	MOVWF      FARG_ByteToHex_output+1
	CALL       _ByteToHex+0
;IRrxSony.c,124 :: 		UART1_Write_Text("\r\nCmd ");
	MOVLW      ?lstr2_IRrxSony+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?lstr2_IRrxSony+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;IRrxSony.c,125 :: 		UART1_Write_Text(word_text);        // Display command number
	MOVLW      _word_text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_word_text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;IRrxSony.c,126 :: 		ByteToHex(device_id,word_text);     // convert number to ASCII hex
	MOVF       _device_id+0, 0
	MOVWF      FARG_ByteToHex_input+0
	MOVLW      _word_text+0
	MOVWF      FARG_ByteToHex_output+0
	MOVLW      hi_addr(_word_text+0)
	MOVWF      FARG_ByteToHex_output+1
	CALL       _ByteToHex+0
;IRrxSony.c,127 :: 		UART1_Write_Text(" Ad ");
	MOVLW      ?lstr3_IRrxSony+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?lstr3_IRrxSony+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;IRrxSony.c,128 :: 		UART1_Write_Text(word_text);        // Display device number
	MOVLW      _word_text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_word_text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;IRrxSony.c,130 :: 		}
L_main17:
;IRrxSony.c,131 :: 		}
	GOTO       L_main15
;IRrxSony.c,132 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
