#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/IRrxSonyInt2LED/IRrxSony.c"
#line 27 "C:/PIC/MikroC/PIC18/PIC18F45K22/IRrxSonyInt2LED/IRrxSony.c"
unsigned int counter;
unsigned int input_data;
unsigned char bit_count;
unsigned char current_state;
unsigned char ir_found;
unsigned char command_id;
unsigned char device_id;

void interrupt(){
 if (INT0IF_bit){
 switch(current_state){
 case 1:
 current_state = 2;
 INTEDG0_bit = 1;
 break;
 case 2:
 counter = TMR1L;
 counter += (TMR1H * 256);
 if((counter > 2000) && (counter < 2800)){
 bit_count = 0;
 input_data = 0;
 current_state = 3;
 }
 else{
 current_state = 1;
 INTEDG0_bit = 0;
 }
 break;
 case 3:


 counter = TMR1L;
 counter += (TMR1H * 256);
 bit_count++;
 input_data >>= 1;

 if(counter > 1500){
 input_data |= 0x8000;
 }
 if (bit_count == 12){
 ir_found = 1;
 input_data >>= 4;
 current_state = 1;
 }
 break;
 default: current_state = 1;
 }
 TMR1H = 0x00;
 TMR1L = 0x00;
 INT0IF_bit = 0;
 }

 if (TMR1IF_bit)
 {
 current_state = 1;
 TMR1IF_bit = 0;
 }
}


void main() {
 OSCCON = 0x70;
 ANSELA = 0x00;
 TRISA = 0x04;
 LATA = 0;
 ANSELB = 0x00;
 TRISB = 0x01;
 LATB = 0;
 ANSELC = 0x00;
 TRISC = 0x00;
 LATC = 0;
 ANSELD = 0x00;
 TRISD = 0x00;
 LATD = 0;

 INTEDG0_bit = 0;

 T1CON = 0x31;
 TMR1H = 0x00;
 TMR1L = 0x00;
 INTCON = 0xC0;
 TMR1IE_bit = 1;
 INT0IE_bit = 1;

 current_state = 1;
 counter = 0;
 ir_found = 0;

 while(1){
 if(ir_found){
 command_id = input_data & 0x7F;
 LATD = command_id;
 device_id = input_data >> 7;
 LATC = device_id;
 ir_found = 0;
 if(device_id == 1){
 switch(command_id){
 case 0:
 LATA.B0 = !LATA.B0;
 break;
 case 1:
 LATA.B1 = !LATA.B1;
 break;
 case 2:
 LATA.B4 = !LATA.B4;
 break;
 case 3:
 LATA.B5 = !LATA.B5;
 break;
 case 8:
 LATA = 0xff;
 break;
 case 9:
 LATA = 0;
 break;
 }
 Delay_ms(100);

 current_state = 1;
 counter = 0;
 ir_found = 0;
 }
 }
 }
}
